//---------------------------------------------------------------------------
#ifndef Unit1H
#define Unit1H
//---------------------------------------------------------------------------
#include <Classes.hpp>
#include <Controls.hpp>
#include <StdCtrls.hpp>
#include <Forms.hpp>
#include <ExtCtrls.hpp>
#include <ActnList.hpp>
#include <Buttons.hpp>
#include <ComCtrls.hpp>
#include <ToolWin.hpp>
#include <ImgList.hpp>
#include <Dialogs.hpp>
#include <SyncObjs.hpp>
//---------------------------------------------------------------------------
#ifndef COUNTOF
#define COUNTOF(x) (sizeof(x)/sizeof(x[0]))
#endif

class TGridItem
{
public:
    TGridItem(int x, int y);
    ~TGridItem();
    inline int getPoint(int x, int y) { return *(note + maxx * y + x); }
    inline void setPoint(int x, int y, int ch = 1) { *(note + maxx * y + x) = ch; }
    void Load(HANDLE h);
    void Save(HANDLE h);
    const int maxx, maxy;
private:
    int* note;
};

class TMainForm : public TForm
{
__published:	// IDE Ǘ̃R|[lg
    TImage *Image1;
    TToolBar *ToolBar1;
    TActionList *ActionList1;
    TImageList *ImageList1;
    TToolButton *ToolButton1;
    TToolButton *ToolButton2;
    TToolButton *ToolButton3;
    TToolButton *ToolButton4;
    TToolButton *ToolButton5;
    TAction *ActionFileNew;
    TAction *ActionFileOpen;
    TAction *ActionFileSave;
    TOpenDialog *OpenDialog;
    TSaveDialog *SaveDialog;
    TPanel *Panel1;
    TStaticText *StaticText1;
    TStaticText *StaticText2;
    TStaticText *StaticText3;
    TStaticText *StaticText4;
    TStaticText *StaticText5;
    TStaticText *StaticText6;
    TStaticText *StaticText7;
    TStaticText *StaticText8;
    TToolButton *ToolButton6;
    TToolButton *ToolButton7;
    TAction *ActionExit;
    TTrackBar *TrackBar;
    TPanel *Panel2;
    TImage *ImageS1;
    TImage *ImageS2;
    TImage *ImageS3;
    TImage *ImageS4;
    TImage *ImageS6;
    TImage *ImageS5;
    TImage *ImageS7;
    TImage *ImageS8;
    TAction *ActionCanvasChanged;
    TStatusBar *StatusBar1;
    TToolButton *ToolButtonRecording;
    TToolButton *ToolButton10;
    TAction *ActionRecording;
    TAction *ActionRecStop;
    void __fastcall Image1MouseUp(TObject *Sender, TMouseButton Button,
          TShiftState Shift, int X, int Y);
    void __fastcall ActionFileNewExecute(TObject *Sender);
    void __fastcall ActionFileOpenExecute(TObject *Sender);
    void __fastcall ActionFileSaveExecute(TObject *Sender);
    void __fastcall StaticText1Click(TObject *Sender);
    void __fastcall ActionExitExecute(TObject *Sender);
    void __fastcall TrackBarChange(TObject *Sender);
    void __fastcall ActionCanvasChangedExecute(TObject *Sender);
    void __fastcall ActionRecordingExecute(TObject *Sender);
    void __fastcall ActionRecStopExecute(TObject *Sender);
private:	// [U[錾
    enum {
        ITEM_COUNT = 8,
    };
    TGridItem* items[ITEM_COUNT];
    int currItem;
    void DrawGrid(bool point = false);
    void __fastcall DrawFocus(TCanvas*, bool lost = false);
    void __fastcall CreateMidi(HANDLE);
    HMIDIOUT hMIDI;
    int baseCycle, baseNote;
    int midCycle;
    UINT timerID;
    int currChannel;
    UINT uiTick, uiRes;
    int h, w, xmax, ymax, xmid, ymid;
    TStaticText* currentColor;
    TCanvas* canvases[ITEM_COUNT];
    TMemoryStream* midiStrm;
    TCriticalSection* crit;
    static BYTE Abase1[][12];
    static BYTE Abase2[][12];
public:		// [U[錾
    __fastcall TMainForm(TComponent* Owner);
    __fastcall ~TMainForm();
    void BaseLine();
    LRESULT OnDrawTick(TMessage);
    const static TColor chColor[];
protected:
    BEGIN_MESSAGE_MAP
    VCL_MESSAGE_HANDLER(WM_APP, TMessage, OnDrawTick)
    END_MESSAGE_MAP(TForm)
};
//---------------------------------------------------------------------------
extern PACKAGE TMainForm *MainForm;
//---------------------------------------------------------------------------
#endif
